Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/WcfService.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/WcfService.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Communication/3.3/WcfService.cs	(revision 4368)
@@ -22,18 +22,14 @@
 using System;
 using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.ServiceModel;
-using HeuristicLab.Hive.Contracts.Interfaces;
-using HeuristicLab.Hive.Slave.Common;
-using HeuristicLab.PluginInfrastructure;
 using System.IO;
 using System.Runtime.Serialization.Formatters.Binary;
-using HeuristicLab.Tracing;
+using System.ServiceModel;
 using HeuristicLab.Hive.Contracts;
 using HeuristicLab.Hive.Contracts.BusinessObjects;
-using HeuristicLab.Hive.Slave.Communication.SlaveService;
 using HeuristicLab.Hive.Contracts.ResponseObjects;
-using HeuristicLab.Hive.Slave.Communication.Properties;
+using HeuristicLab.Hive.Slave.Common;
+using HeuristicLab.Hive.Slave.Communication.SlaveFacade;
+using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Slave.Communication {
@@ -78,6 +74,4 @@
     public event EventHandler Connected;
 
-    SlaveServiceCache servicePool;
-
     /// <summary>
     /// Constructor
@@ -92,6 +86,8 @@
     /// </summary>
     public void Connect() {
-      servicePool = new SlaveServiceCache(ServerIp);
-      using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
+      ServiceLocator.Instance.HostAddress = ServerIp;
+      ServiceLocator.Instance.SlaveFacadePool.ExceptionOccured += new EventHandler<HeuristicLab.Common.EventArgs<Exception>>(ClientFacadePool_ExceptionOccured);
+      ServiceLocator.Instance.StreamedSlaveFacadePool.ExceptionOccured += new EventHandler<HeuristicLab.Common.EventArgs<Exception>>(ClientFacadePool_ExceptionOccured);
+      using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
         try {
           Logger.Debug("Starting the Connection Process");
@@ -114,4 +110,8 @@
         }
       }
+    }
+
+    void ClientFacadePool_ExceptionOccured(object sender, HeuristicLab.Common.EventArgs<Exception> e) {
+      Logger.Error("An exception occured in the WCF-Communication: " + e.Value.ToString());
     }
 
@@ -138,9 +138,9 @@
     /// </summary>
     public void Login(SlaveDto slaveInfo) {
-      using (DisposableSlaveFacadeClient client = servicePool.GetSlaveFacade()) {
+      using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.SlaveFacadePool.GetService()) {
         try {
           if (ConnState == NetworkEnum.WcfConnState.Connected) {
             Logger.Debug("STARTED: Login Sync");
-            Response res = client.Login(slaveInfo);
+            Response res = service.Obj.Login(slaveInfo);
             if (res.StatusMessage != ResponseStatus.Ok) {
               Logger.Error("FAILED: Login Failed! " + res.StatusMessage);
@@ -165,7 +165,7 @@
     public void GetJobAsync(Guid guid) {
       if (LoggedIn) {
-        DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade();
+        Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
         Logger.Debug("STARTED: Fetching of Jobs from Server for Slave");
-        client.BeginGetStreamedJob(guid, (ar => {
+        service.Obj.BeginGetStreamedJob(guid, (ar => {
           if (ar.IsCompleted) {
             Stream stream = null;
@@ -173,5 +173,5 @@
             try {
               Logger.Debug("ENDED: Fetching of Jobs from Server for Slave");
-              stream = client.EndGetStreamedJob(ar);
+              stream = service.Obj.EndGetStreamedJob(ar);
 
               //first deserialize the response
@@ -203,5 +203,5 @@
                 memStream.Dispose();
 
-              servicePool.ReleaseSlaveClient(client);
+              service.Dispose();
             }
           } else
@@ -220,5 +220,5 @@
     public void GetFinishedJobResultAsync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception, bool finished) {
       if (LoggedIn) {
-        DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade();
+        Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
         Logger.Debug("STARTED: Sending back the finished job results");
         Logger.Debug("Building stream");
@@ -226,6 +226,6 @@
         Logger.Debug("Builded stream");
         Logger.Debug("Making the call");
-
-        client.BeginStoreFinishedJobResultStreamed(stream, (ar => {
+        
+        service.Obj.BeginStoreFinishedJobResultStreamed(stream, (ar => {
           try {
             Logger.Debug("Finished storing the job");
@@ -234,5 +234,5 @@
 
             if (ar.IsCompleted) {
-              var res = client.EndStoreFinishedJobResultStreamed(ar);
+              var res = service.Obj.EndStoreFinishedJobResultStreamed(ar);
               StoreFinishedJobResultCompletedEventArgs args = new StoreFinishedJobResultCompletedEventArgs(new object[] { res }, null, false, null);
               Logger.Debug("calling the Finished Job Event");
@@ -244,5 +244,5 @@
           }
           finally {
-            servicePool.ReleaseSlaveClient(client);
+            service.Dispose();
           }
         }), null);
@@ -256,8 +256,8 @@
     public void ProcessSnapshotAsync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception, bool finished) {
       if (LoggedIn) {
-        DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade();
+        Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService();
 
         Stream stream = GetStreamedJobResult(clientId, jobId, result, percentage, exception);
-        client.BeginProcessSnapshotStreamed(stream, (ar => {
+        service.Obj.BeginProcessSnapshotStreamed(stream, (ar => {
           try {
             if (stream != null)
@@ -265,5 +265,5 @@
 
             if (ar.IsCompleted) {
-              var res = client.EndStoreFinishedJobResultStreamed(ar);
+              var res = service.Obj.EndStoreFinishedJobResultStreamed(ar);
               ProcessSnapshotCompletedEventArgs args = new ProcessSnapshotCompletedEventArgs(new object[] { res }, null, false, null);
               ProcessSnapshotCompleted(this, args);
@@ -273,5 +273,5 @@
           }
           finally {
-            servicePool.ReleaseSlaveClient(client);
+            service.Dispose();
           }
         }), null);
@@ -289,11 +289,13 @@
     public void ProcessHeartBeatSync(HeartBeatData hbd) {
       if (LoggedIn) {
-        using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
           Logger.Debug("STARTING: sending heartbeat");
-          var res = client.ProcessHeartBeat(hbd);
+          var res = service.Obj.ProcessHeartBeat(hbd);
 
           if (res.StatusMessage == ResponseStatus.Ok) {
             ProcessHeartBeatCompleted(this, new ProcessHeartBeatCompletedEventArgs(new object[] { res }, null, false, null));
             Logger.Debug("ENDED: sending heartbeats");
+          } else if (res.StatusMessage == ResponseStatus.ProcessHeartBeat_UserNotLoggedIn) {
+            LoggedIn = false;
           } else {
             Logger.Error("FAILED: sending heartbeats: " + res.StatusMessage.ToString());
@@ -311,5 +313,5 @@
       JobResult jobResult = new JobResult();
       jobResult.SlaveId = clientId;
-      jobResult.JobId = jobId;
+      jobResult.Id = jobId;
       jobResult.Percentage = percentage;
       jobResult.Exception = exception != null ? exception.Message : "";
@@ -328,6 +330,6 @@
 
     public ResponseResultReceived StoreFinishedJobResultsSync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception, bool finished) {
-      using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
-        ResponseResultReceived res = client.StoreFinishedJobResultStreamed(GetStreamedJobResult(clientId, jobId, result, percentage, exception));
+      using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+        ResponseResultReceived res = service.Obj.StoreFinishedJobResultStreamed(GetStreamedJobResult(clientId, jobId, result, percentage, exception));
         return res;
       }
@@ -337,6 +339,6 @@
       try {
         Logger.Debug("STARTING: Sync call: IsJobStillNeeded");
-        using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
-          Response res = client.IsJobStillNeeded(jobId);
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          Response res = service.Obj.IsJobStillNeeded(jobId);
           Logger.Debug("ENDED: Sync call: IsJobStillNeeded");
           return res;
@@ -351,6 +353,6 @@
     public ResponseResultReceived ProcessSnapshotSync(Guid clientId, Guid jobId, byte[] result, double percentage, Exception exception) {
       try {
-        using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
-          return client.ProcessSnapshotStreamed(GetStreamedJobResult(clientId, jobId, result, percentage, exception));
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          return service.Obj.ProcessSnapshotStreamed(GetStreamedJobResult(clientId, jobId, result, percentage, exception));
         }
       }
@@ -363,8 +365,8 @@
     public IEnumerable<CachedHivePluginInfoDto> RequestPlugins(List<HivePluginInfoDto> requestedPlugins) {
       try {
-        using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
           Logger.Debug("STARTED: Requesting Plugins for Job");
           Logger.Debug("STARTED: Getting the stream");
-          Stream stream = client.GetStreamedPlugins(requestedPlugins.ToArray());
+          Stream stream = service.Obj.GetStreamedPlugins(requestedPlugins.ToArray());
           Logger.Debug("ENDED: Getting the stream");
           BinaryFormatter formatter = new BinaryFormatter();
@@ -386,6 +388,6 @@
       try {
         Logger.Debug("STARTED: Logout");
-        using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
-          client.Logout(guid);
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          service.Obj.Logout(guid);
         }
         Logger.Debug("ENDED: Logout");
@@ -399,6 +401,6 @@
       try {
         Logger.Debug("STARTED: Syncing Calendars");
-        using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
-          ResponseCalendar cal = client.GetCalendar(clientId);
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          ResponseCalendar cal = service.Obj.GetCalendar(clientId);
           Logger.Debug("ENDED: Syncing Calendars");
           return cal;
@@ -414,6 +416,6 @@
       try {
         Logger.Debug("STARTED: Setting Calendar status to: " + state);
-        using (DisposableSlaveFacadeClient client = servicePool.GetStreamedSlaveFacade()) {
-          Response resp = client.SetCalendarStatus(clientId, state);
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          Response resp = service.Obj.SetCalendarStatus(clientId, state);
           Logger.Debug("ENDED: Setting Calendar status to: " + state);
           return resp;
@@ -425,4 +427,56 @@
       }
     }
+
+    public ResponseObject<JobDto> AddChildJob(Guid parentJobId, SerializedJob serializedJob) {
+      try {
+        Logger.Debug("STARTED: Add Child Job for parent: " + parentJobId);
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          ResponseObject<JobDto> response = service.Obj.AddChildJob(parentJobId, serializedJob);
+          Logger.Debug("ENDED: Add Child Job for parent: " + parentJobId);
+          return response;
+        }
+      }
+      catch (Exception e) {
+        HandleNetworkError(e);
+        return null;
+      }
+    }
+
+    public ResponseObject<JobDto> PauseJob(SerializedJob serializedJob) {
+      try {
+        Logger.Debug("STARTED: Pausing job: " + serializedJob.JobInfo.Id);
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          ResponseObject<JobDto> response = service.Obj.PauseJob(serializedJob);
+          Logger.Debug("ENDED: Pausing job: " + serializedJob.JobInfo.Id);
+          return response;
+        }
+      }
+      catch (Exception e) {
+        HandleNetworkError(e);
+        return null;
+      }
+    }
+
+    public ResponseObject<SerializedJobList> GetChildJobs(Guid parentJob) {
+      try {
+        Logger.Debug("STARTED: GetChildJobs job: " + parentJob);
+        using (Disposable<SlaveFacade.ISlaveFacade> service = ServiceLocator.Instance.StreamedSlaveFacadePool.GetService()) {
+          SerializedJobList serializedJobs = new SerializedJobList();
+          JobResult[] results = service.Obj.GetChildJobResults(new Guid?(parentJob), false, false);
+          foreach (JobResult result in results) {
+            serializedJobs.Add(service.Obj.GetLastSerializedResult(result.Id));
+          }
+
+          Logger.Debug("ENDED: GetChildJobs job: " + parentJob);
+          return new ResponseObject<SerializedJobList>() {
+            Obj = serializedJobs
+          };
+        }
+      }
+      catch (Exception e) {
+        HandleNetworkError(e);
+        return null;
+      }
+    }
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Console/3.3/Properties/AssemblyInfo.frame
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Console/3.3/Properties/AssemblyInfo.frame	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Console/3.3/Properties/AssemblyInfo.frame	(revision 4368)
@@ -55,5 +55,4 @@
 // by using the '*' as shown below:
 // [assembly: AssemblyVersion("1.0.*")]
-[assembly: AssemblyVersion("3.3.0.$WCREV$")]
+[assembly: AssemblyVersion("3.3.0.0")]
 [assembly: AssemblyFileVersion("3.3.0.$WCREV$")]
-[assembly: AssemblyBuildDate("$WCNOW$")]
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/Core.cs	(revision 4368)
@@ -30,10 +30,10 @@
 using HeuristicLab.Hive.Slave.Common;
 using HeuristicLab.Hive.Slave.Communication;
-using HeuristicLab.Hive.Slave.Core.SlaveConsoleService;
+using HeuristicLab.Hive.Slave.Communication.SlaveFacade;
 using HeuristicLab.Hive.Slave.Core.ConfigurationManager;
 using HeuristicLab.Hive.Slave.Core.JobStorage;
+using HeuristicLab.Hive.Slave.Core.SlaveConsoleService;
 using HeuristicLab.Hive.Slave.ExecutionEngine;
 using HeuristicLab.Tracing;
-using HeuristicLab.Hive.Slave.Communication.SlaveService;
 
 namespace HeuristicLab.Hive.Slave.Core {
@@ -205,5 +205,44 @@
           WcfService.Instance.Logout(ConfigManager.Instance.GetClientInfo().Id);
           break;
-      }
+
+        case MessageContainer.MessageType.AddChildJob:
+          AddChildJob((MessageContainerWithJob)container);
+          break;
+
+        case MessageContainer.MessageType.PauseJob:
+          // send the job back to hive
+          PauseJob((MessageContainerWithJob)container);
+          break;
+
+        case MessageContainer.MessageType.GetChildJobs:
+          // send the job back to hive
+          GetChildJobs((MessageContainerWithCallback<SerializedJobList>)container);
+          break;
+      }
+    }
+
+    private void GetChildJobs(MessageContainerWithCallback<SerializedJobList> mc) {
+      ResponseObject<SerializedJobList> response = wcfService.GetChildJobs(mc.JobId);
+      if (response.StatusMessage != ResponseStatus.Ok) {
+        Logger.Error("GetChildJobs failed: " + response.StatusMessage);
+      } else {
+        mc.Callback(response.Obj);
+      }
+    }
+
+    private void PauseJob(MessageContainerWithJob mc) {
+      ResponseObject<JobDto> response = wcfService.PauseJob(mc.SerializedJob);
+      KillAppDomain(mc.JobId);
+      if (response.StatusMessage != ResponseStatus.Ok) {
+        Logger.Error("PauseJob failed: " + response.StatusMessage);
+      }
+    }
+
+    private ResponseObject<JobDto> AddChildJob(MessageContainerWithJob mc) {
+      ResponseObject<JobDto> response = wcfService.AddChildJob(mc.JobId, mc.SerializedJob);
+      if (response.StatusMessage != ResponseStatus.Ok) {
+        Logger.Error("AddChildJob failed: " + response.StatusMessage);
+      }
+      return response;
     }
 
@@ -462,4 +501,5 @@
             appDomains.Remove(id);
           }
+
           engines.Remove(id);
           jobs.Remove(id);
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeartbeatManager.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeartbeatManager.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeartbeatManager.cs	(revision 4368)
@@ -33,5 +33,5 @@
 using HeuristicLab.Tracing;
 using System.Threading;
-using HeuristicLab.Hive.Slave.Communication.SlaveService;
+using HeuristicLab.Hive.Slave.Communication.SlaveFacade;
 
 namespace HeuristicLab.Hive.Slave.Core {
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeuristicLab.Hive.Slave.Core-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeuristicLab.Hive.Slave.Core-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/HeuristicLab.Hive.Slave.Core-3.3.csproj	(revision 4368)
@@ -77,4 +77,5 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Common-3.3">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Common-3.3.dll</HintPath>
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/PluginCache.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/PluginCache.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.Core/3.3/PluginCache.cs	(revision 4368)
@@ -10,4 +10,5 @@
 using HeuristicLab.Tracing;
 using System.Reflection;
+using System.Threading;
 
 namespace HeuristicLab.Hive.Slave.Core {
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/Executor.cs	(revision 4368)
@@ -30,4 +30,7 @@
 using System.IO;
 using HeuristicLab.Core;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Collections.Generic;
+using System.Linq;
 
 namespace HeuristicLab.Hive.Slave.ExecutionEngine {
@@ -57,10 +60,53 @@
     public void Start(byte[] serializedJob) {
       CreationTime = DateTime.Now;
-      Job = XmlParser.Deserialize<IJob>(new MemoryStream(serializedJob));
+      Job = DeserializeJobObject(serializedJob);
 
       Job.JobStopped += new EventHandler(Job_JobStopped);
       Job.JobFailed += new EventHandler(Job_JobFailed);
-      Job.Prepare();
-      Job.Start();
+      Job.NewChildJob += new EventHandler<EventArgs<IJob>>(Job_NewChildJob);
+      Job.WaitForChildJobs += new EventHandler(Job_WaitForChildJobs);
+
+      if (Job.ExecutionState == Core.ExecutionState.Paused) {
+        Queue.AddMessage(new MessageContainerWithCallback<SerializedJobList>(MessageContainer.MessageType.GetChildJobs, JobId,
+          (childjobs) => {
+            Job.Resume(childjobs.Select(j => DeserializeJobObject(j.SerializedJobData)));
+          }
+        ));
+      } else {
+        Job.Prepare();
+        Job.Start();
+      }
+    }
+
+    void Job_NewChildJob(object sender, EventArgs<IJob> e) {
+      byte[] jobByteArray = SerializeJobObject(e.Value);
+
+      SerializedJob serializedJob = new SerializedJob() {
+        JobInfo = new JobDto() {
+          State = JobState.Offline,
+          CoresNeeded = e.Value.CoresNeeded,
+          MemoryNeeded = e.Value.MemoryNeeded,
+          PluginsNeeded = HivePluginInfoDto.FindPluginsNeeded(e.Value.GetType()),
+        },
+        SerializedJobData = jobByteArray
+      };
+
+      Queue.AddMessage(new MessageContainerWithJob(MessageContainer.MessageType.AddChildJob, this.JobId, serializedJob));
+    }
+
+    void Job_WaitForChildJobs(object sender, EventArgs e) {
+      // Pause the job and send it back to the hive. The server will awake it when all child-jobs are finished
+      byte[] jobByteArray = SerializeJobObject(Job);
+
+      SerializedJob serializedJob = new SerializedJob() {
+        JobInfo = new JobDto() {
+          Id = JobId,
+          State = JobState.WaitForChildJobs
+        },
+        SerializedJobData = jobByteArray
+      };
+
+      JobIsFinished = true;
+      Queue.AddMessage(new MessageContainerWithJob(MessageContainer.MessageType.PauseJob, this.JobId, serializedJob));
     }
 
@@ -101,5 +147,5 @@
         CurrentMessage = MessageContainer.MessageType.NoMessage;
         // Pack the whole job inside an xml document
-        byte[] job = SerializeJobObject();
+        byte[] job = SerializeJobObject(Job);
         // Restart the job
         // Return the Snapshot
@@ -113,5 +159,5 @@
         throw new InvalidStateException("Job is still running");
       } else {
-        byte[] jobArr = SerializeJobObject();
+        byte[] jobArr = SerializeJobObject(Job);
         return jobArr;
       }
@@ -123,12 +169,21 @@
     }
 
-    private byte[] SerializeJobObject() {
-      MemoryStream stream = new MemoryStream();
-      XmlGenerator.Serialize(Job, stream);
-      return stream.ToArray();
+    private byte[] SerializeJobObject(IJob job) {
+      MemoryStream memStream = new MemoryStream();
+      XmlGenerator.Serialize(job, memStream);
+      byte[] jobByteArray = memStream.ToArray();
+      memStream.Dispose();
+      return jobByteArray;
+    }
+
+    private IJob DeserializeJobObject(byte[] sjob) {
+      MemoryStream memStream = new MemoryStream(sjob);
+      IJob job = XmlParser.Deserialize<IJob>(memStream);
+      memStream.Dispose();
+      return job;
     }
 
     private void RestoreJobObject(byte[] sjob) {
-      Job = XmlParser.Deserialize<IJob>(new MemoryStream(sjob));
+      Job = DeserializeJobObject(sjob);
     }
 
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/HeuristicLab.Hive.Slave.ExecutionEngine-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/HeuristicLab.Hive.Slave.ExecutionEngine-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Slave.ExecutionEngine/3.3/HeuristicLab.Hive.Slave.ExecutionEngine-3.3.csproj	(revision 4368)
@@ -76,10 +76,12 @@
   </PropertyGroup>
   <ItemGroup>
+    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Common-3.3">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Common-3.3.dll</HintPath>
     </Reference>
-    <Reference Include="HeuristicLab.Core-3.3" >
+    <Reference Include="HeuristicLab.Core-3.3">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Core-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.DataAccess-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Persistence-3.3">
       <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Persistence-3.3.dll</HintPath>
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Tracing/3.3/HeuristicLab.Hive.Tracing-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Tracing/3.3/HeuristicLab.Hive.Tracing-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Tracing/3.3/HeuristicLab.Hive.Tracing-3.3.csproj	(revision 4368)
@@ -23,4 +23,6 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -31,4 +33,66 @@
     <ErrorReport>prompt</ErrorReport>
     <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\HeuristicLab.Hive.Tracing-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\HeuristicLab.Hive.Tracing-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x86'">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Debug\HeuristicLab.Hive.Tracing-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisRuleDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <CodeAnalysisLogFile>bin\Release\HeuristicLab.Hive.Tracing-3.3.dll.CodeAnalysisLog.xml</CodeAnalysisLogFile>
+    <CodeAnalysisUseTypeNameInSuppression>true</CodeAnalysisUseTypeNameInSuppression>
+    <CodeAnalysisModuleSuppressionsFile>GlobalSuppressions.cs</CodeAnalysisModuleSuppressionsFile>
+    <ErrorReport>prompt</ErrorReport>
+    <CodeAnalysisRuleSet>MinimumRecommendedRules.ruleset</CodeAnalysisRuleSet>
+    <CodeAnalysisRuleSetDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\\Rule Sets</CodeAnalysisRuleSetDirectories>
+    <CodeAnalysisIgnoreBuiltInRuleSets>false</CodeAnalysisIgnoreBuiltInRuleSets>
+    <CodeAnalysisRuleDirectories>;c:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
+    <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
   </PropertyGroup>
   <ItemGroup>
